   var APPLET      =  "APFLOAT"; //ultilize  "APFLOAT" ,  "BIGDECIMAL" ,  "FLOAT"
   var NumLinhas   = 12;
   var NumColunas  = 3;
   var NomeEnt     = "<big>a</big> <big>b</big> <big>x</big><sub>0</sub> <big>d</big><sub>x</sub>";
   var IDEnt       = "a b x dx";
   var CoefEnt     = "2 1 0 1";
   var EntEdit     = "1 1 1 1";
   var  CORESCOLUNAS = "#c0e0ff #dadbb7 #80e0d0";
   var  TITULOSCOLUNAS = "<i>x<sub>n</sub></> <i>f</>(<i>x<sub>n</sub></>) <i>&#916;y<sub>n</sub></>";
	var CASAS=5;
// JavaScript Document

function include( arquivo )
{
   var novo = document.createElement( 'script' );
   novo.setAttribute( 'type', 'text/javascript' );
   novo.setAttribute( 'src', arquivo );
   document.getElementsByTagName( 'head' )[0].appendChild( novo );
}



include( "javascript/Tabela.js" );
include( "javascript/Entradas.js" );
include( "javascript/Function.js" );
include("javascript/bignumber.js");
include("javascript/validanumero.js");

function fx(a, x)
{

   var i;
   var valor="0";
 for(i = 0; i < a.length; i ++ )
   {
		try{      //tente executar 
			document.getElementById(APPLET).setPrecisao(50)
			var pow=document.getElementById(APPLET).pow(x,i);
			var multiply=document.getElementById(APPLET).multiply(a[a.length-i-1],pow.toString());
			valor=document.getElementById(APPLET).add(valor.toString(),multiply.toString());

		}catch(e) {  //Se no conseguir ou se der algum erro
			return 0;
		}
   }
   return valor;
}

function preenche(entradas,tabela, vetEnt)
{
   var NUMBER_GAP = 20; // em pixel
   var GAP = 30; // em pixel
   var f = window.frames["color-picker1"];
   var func = document.getElementById("funcao");
   var graphic = document.atividadeB;
   var entradas=f.getABX0DX();
   var col = 2;
   var X =entradas.x0.toString();
   var DX =entradas.dx.toString();
   var a = entradas.a.toString();
   var b = entradas.b.toString();
   var elementsA = new Array();
   var text = getFunction(a, b);
   elementsA.push(a);
   elementsA.push(b);
   var tempX = X;
   var bYIsMinorAxis;
   var bYIsHigherAxis;
   var nGreaterFx;
   var nMinorFx;
   var nFx;
   var diffX, diffY;
   var ratio = graphic.width / graphic.height; // no sei como pegar as dimenses do arquivo geogebra
   var ratioXY;
   var preferredMax;
   var arrCoordSystem;
   var widthPercentage;
   var n = 6;
   var nGap; // em coordenadas do sistema

	graphic.setValue("a", entradas.a);
	graphic.setValue("b", entradas.b);
	graphic.setValue("d", entradas.x0);
	graphic.setValue("\u0394x", entradas.dx);
   func.innerHTML = text;
   for(var i = 1; i < tabela.NumLinha; i ++)
   {
      for(var j = 0; j < col; j += 2)
      {
		 nFx = fx(elementsA, tempX);
         tabela.Matriz[i][j] = convetParaVisualizacao(arredondamento(tempX,CASAS));
         tabela.Matriz[i][j + 1] = convetParaVisualizacao(arredondamento(nFx,CASAS));
      }
	  if ((i == 1 && entradas.a >= 0) || (i == n && entradas.a < 0))
	  	nMinorFx = nFx;
	  else if ((i == n && entradas.a >= 0) || (i == 1 && entradas.a < 0))
	  	nGreaterFx = nFx;
      tempX=document.getElementById(APPLET).add(tempX,DX);
    }
	arrCoordSystem = new Array(Math.min(entradas.x0, 0), Math.max(entradas.x0 + (n - 1) * entradas.dx, 0), Math.min(nMinorFx, 0), Math.max(nGreaterFx, 0));
   diffX = Math.abs(arrCoordSystem[1] - arrCoordSystem[0]);
   diffY = Math.abs(arrCoordSystem[3] - arrCoordSystem[2]);
   
   ratioXY = diffX / diffY;
   if (ratioXY > ratio)
   {
	   nGap = GAP / graphic.width * diffX;
		diffX += 2 * nGap;
		arrCoordSystem[0] -= nGap;
		arrCoordSystem[1] += nGap;
		arrCoordSystem[2] -= nGap;
		arrCoordSystem[3] += nGap;
   }
   else
   {
	   nGap = GAP / graphic.height * diffY;
		diffX += 2 * nGap;
		arrCoordSystem[0] -= nGap;
		arrCoordSystem[1] += nGap;
		arrCoordSystem[2] -= nGap;
		arrCoordSystem[3] += nGap;
   }
   
   if (ratioXY > ratio)
   {
	   preferredMax = (1 / ratio * diffX);
	   if (entradas.a > 0)
     	 arrCoordSystem[3] += preferredMax - diffY;
	   else
	     arrCoordSystem[2] -= preferredMax - diffY;
   }
   else
   {
	   preferredMax = ratio * diffY;
	   arrCoordSystem[1] += preferredMax - diffX;
   }
   graphic.setCoordSystem(arrCoordSystem[0], arrCoordSystem[1], arrCoordSystem[2], arrCoordSystem[3]);
	  var tf,ti;
     for(var w = col;w < tabela.NumCol;
      w ++ ){
	   for(var i = 1; i < tabela.NumLinha-1; i ++)
   		{	
		try{      //tente executar 
		  tf = convetParaProcessamento(tabela.Matriz[i+1][w-1]);
          	  ti = convetParaProcessamento(tabela.Matriz[i][w-1]);
	      var resultado=document.getElementById(APPLET).subtract(tf.toString(),ti.toString());
		  tabela.Matriz[i][w] = convetParaVisualizacao(resultado);
		}catch(e) {  //Se no conseguir ou se der algum erro
			//Informar o erro
			alert("erro try2 "+e);
		}
           }
      }
}

    function redraw(ent,tab)
    {
    preenche(ent,tab, IDEnt.split( " " ));
    tab.draw( "bowlData" );
    }
function main()
{
   var tab = new Tabela();
   tab.init(NumLinhas, NumColunas, TITULOSCOLUNAS.split( " " ), CORESCOLUNAS.split( " " ));
   tab.draw( "bowlData" );
   var ent = new Entradas();
   var f = window.frames["color-picker1"];
   f.onmouseup = function () {
     redraw(ent,tab);
	};
   ent.init( NomeEnt.split( " " ), IDEnt.split( " " ), CoefEnt.split( " " ), EntEdit.split( " " ) );
   ent.printEntradas( "inputData" );
  redraw(ent,tab);
}
function arredondamento(valor,casas) {
	var novo=Math.round(valor*Math.pow(10,casas))/Math.pow(10,casas);
	return novo;
}
window.onload = main


